/*
**  ASTq -- Abstract Syntax Tree (AST) Query Engine
**  Copyright (c) 2014-2015 Ralf S. Engelschall <rse@engelschall.com>
**
**  Permission is hereby granted, free of charge, to any person obtaining
**  a copy of this software and associated documentation files (the
**  "Software"), to deal in the Software without restriction, including
**  without limitation the rights to use, copy, modify, merge, publish,
**  distribute, sublicense, and/or sell copies of the Software, and to
**  permit persons to whom the Software is furnished to do so, subject to
**  the following conditions:
**
**  The above copyright notice and this permission notice shall be included
**  in all copies or substantial portions of the Software.
**
**  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
**  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
**  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
**  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
**  CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
**  TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
**  SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

(function(f){if(typeof exports==="object"&&typeof module!=="undefined"){module.exports=f()}else if(typeof define==="function"&&define.amd){define([],f)}else{var g;if(typeof window!=="undefined"){g=window}else if(typeof global!=="undefined"){g=global}else if(typeof self!=="undefined"){g=self}else{g=this}g.ASTQ = f()}})(function(){var define,module,exports;return (function e(t,n,r){function s(o,u){if(!n[o]){if(!t[o]){var a=typeof require=="function"&&require;if(!u&&a)return a(o,!0);if(i)return i(o,!0);var f=new Error("Cannot find module '"+o+"'");throw f.code="MODULE_NOT_FOUND",f}var l=n[o]={exports:{}};t[o][0].call(l.exports,function(e){var n=t[o][1][e];return s(n?n:e)},l,l.exports,e,t,n,r)}return n[o].exports}var i=typeof require=="function"&&require;for(var o=0;o<r.length;o++)s(r[o]);return s})({1:[function(_dereq_,module,exports){
(function (global){
!function(e){if("object"==typeof exports&&"undefined"!=typeof module)module.exports=e();else if("function"==typeof define&&define.amd)define([],e);else{var t;t="undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:this,t.ASTY=e()}}(function(){return function e(t,n,r){function i(a,u){if(!n[a]){if(!t[a]){var f="function"==typeof _dereq_&&_dereq_;if(!u&&f)return f(a,!0);if(o)return o(a,!0);var s=new Error("Cannot find module '"+a+"'");throw s.code="MODULE_NOT_FOUND",s}var l=n[a]={exports:{}};t[a][0].call(l.exports,function(e){var n=t[a][1][e];return i(n?n:e)},l,l.exports,e,t,n,r)}return n[a].exports}for(var o="function"==typeof _dereq_&&_dereq_,a=0;a<r.length;a++)i(r[a]);return i}({1:[function(e,t,n){"use strict";function r(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}Object.defineProperty(n,"__esModule",{value:!0});var i=function(){function e(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(t,n,r){return n&&e(t.prototype,n),r&&e(t,r),t}}(),o=function(){function e(){r(this,e)}return i(e,[{key:"init",value:function(e,t,n,r){if(arguments.length<2)throw new Error("init: invalid number of arguments");if(this.ctx=e,this.ASTy=!0,this.T=t,this.L={L:0,C:0,O:0},this.A={},this.C=[],this.P=null,"object"==typeof n)for(var i in n)n.hasOwnProperty(i)&&this.set(i,n[i]);return"object"==typeof r&&r instanceof Array&&this.add(r),this}},{key:"type",value:function(e){if(0===arguments.length)return this.T;if(1===arguments.length)return this.T=e,this;throw new Error("type: invalid number of arguments")}},{key:"pos",value:function(e,t,n){if(0===arguments.length)return{line:this.L.L,column:this.L.C,offset:this.L.O};if(arguments.length<=3)return this.L.L=e||0,this.L.C=t||0,this.L.O=n||0,this;throw new Error("pos: invalid number of arguments")}},{key:"set",value:function(){for(var e=this,t=arguments.length,n=Array(t),r=0;t>r;r++)n[r]=arguments[r];if(1===n.length&&"object"==typeof n[0])Object.keys(n[0]).forEach(function(t){e.A[t]=n[0][t]});else{if(2!==n.length)throw new Error("set: invalid number of arguments");this.A[n[0]]=n[1]}return this}},{key:"unset",value:function(){for(var e=this,t=arguments.length,n=Array(t),r=0;t>r;r++)n[r]=arguments[r];if(1===n.length&&"object"==typeof n[0]&&n[0]instanceof Array)n[0].forEach(function(t){delete e.A[t]});else{if(1!==n.length)throw new Error("unset: invalid number of arguments");delete this.A[n[0]]}return this}},{key:"get",value:function(e){if(1!==arguments.length)throw new Error("get: invalid number of arguments");if("string"!=typeof e)throw new Error("get: invalid key argument");return this.A[e]}},{key:"attrs",value:function(){return Object.keys(this.A)}},{key:"nth",value:function t(){if(null===this.P)return 1;var t=this.P.C.indexOf(this);if(0>t)throw new Error("nth: internal error -- node not in childs of its parent");return t}},{key:"ins",value:function(e){for(var t=this,n=arguments.length,r=Array(n>1?n-1:0),i=1;n>i;i++)r[i-1]=arguments[i];if(0===r.length)throw new Error("ins: invalid number of arguments");if(0>e&&(e=this.C.length+1-e),!(e>0&&e<this.C.length))throw new Error("ins: invalid position");var o=function(n){if(!t.ctx.isA(n))throw new Error("ins: invalid AST node argument: "+JSON.stringify(n));t.C.splice(e++,0,n),n.P=t};return r.forEach(function(e){"object"==typeof e&&e instanceof Array?e.forEach(function(e){o(e)}):null!==e&&o(e)}),this}},{key:"add",value:function(){for(var e=this,t=arguments.length,n=Array(t),r=0;t>r;r++)n[r]=arguments[r];if(0===n.length)throw new Error("add: invalid number of arguments");var i=function(t){if(!e.ctx.isA(t))throw new Error("add: invalid AST node argument: "+JSON.stringify(t));e.C.push(t),t.P=e};return n.forEach(function(e){"object"==typeof e&&e instanceof Array?e.forEach(function(e){i(e)}):null!==e&&i(e)}),this}},{key:"del",value:function(){for(var e=this,t=arguments.length,n=Array(t),r=0;t>r;r++)n[r]=arguments[r];if(0===n.length)throw new Error("del: invalid number of argument");return n.forEach(function(t){if(!e.ctx.isA(t))throw new Error("del: invalid AST node argument: "+JSON.stringify(t));for(var n=!1,r=0;r<e.C.length;r++)if(e.C[r]===t){e.C.splice(r,1),t.P=null,n=!0;break}if(!n)throw new Error("del: AST node not found in childs")}),this}},{key:"childs",value:function(){return this.C}},{key:"parent",value:function(){return this.P}}]),e}();n["default"]=o,t.exports=n["default"]},{}],2:[function(e,t,n){"use strict";function r(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}Object.defineProperty(n,"__esModule",{value:!0});var i=function(){function e(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(t,n,r){return n&&e(t.prototype,n),r&&e(t,r),t}}(),o=function(){function e(){r(this,e)}return i(e,[{key:"dump",value:function(e){void 0===e&&(e=1/0);var t="";return this.walk(function(n,r){if(!(r>e)){for(var i=0;r>i;i++)t+="    ";t+=n.T+" ";var o=Object.keys(n.A);o.length>0&&!function(){t+="(";var e=!0;o.forEach(function(r){e?e=!1:t+=", ",t+=r+": ";var i=n.A[r];switch(typeof i){case"string":var o=function(e){return e.charCodeAt(0).toString(16).toUpperCase()};t+='"'+i.replace(/\\/g,"\\\\").replace(/"/g,'\\"').replace(/\x08/g,"\\b").replace(/\t/g,"\\t").replace(/\n/g,"\\n").replace(/\f/g,"\\f").replace(/\r/g,"\\r").replace(/[\x00-\x07\x0B\x0E\x0F]/g,function(e){return"\\x0"+o(e)}).replace(/[\x10-\x1F\x80-\xFF]/g,function(e){return"\\x"+o(e)}).replace(/[\u0100-\u0FFF]/g,function(e){return"\\u0"+o(e)}).replace(/[\u1000-\uFFFF]/g,function(e){return"\\u"+o(e)})+'"';break;case"object":t+=i instanceof RegExp?i.source:JSON.stringify(i);break;default:t+=JSON.stringify(i)}}),t+=") "}(),t+="["+n.L.L+"/"+n.L.C+"]\n"}},"downward"),t}}]),e}();n["default"]=o,t.exports=n["default"]},{}],3:[function(e,t,n){"use strict";function r(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}Object.defineProperty(n,"__esModule",{value:!0});var i=function(){function e(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(t,n,r){return n&&e(t.prototype,n),r&&e(t,r),t}}(),o=function(){function e(){r(this,e)}return i(e,[{key:"merge",value:function(e){var t=this,n=arguments.length<=1||void 0===arguments[1]?!1:arguments[1],r=arguments.length<=2||void 0===arguments[2]?{}:arguments[2];if(!this.ctx.isA(e))throw new Error("merge: invalid AST node argument");if(n){var i=e.pos();this.pos(i.L,i.C,i.O)}return e.attrs().forEach(function(n){var i="undefined"!=typeof r[n]?r[n]:n;null!==i&&t.set(i,e.get(n))}),e.childs().forEach(function(e){t.add(e)}),this}}]),e}();n["default"]=o,t.exports=n["default"]},{}],4:[function(e,t,n){"use strict";function r(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}Object.defineProperty(n,"__esModule",{value:!0});var i=function(){function e(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(t,n,r){return n&&e(t.prototype,n),r&&e(t,r),t}}(),o=function(){function e(){r(this,e)}return i(e,null,[{key:"serialize",value:function(e,t){var n=function r(e){var t={T:e.T,L:{L:e.L.L,C:e.L.C,O:e.L.O}},n=Object.keys(e.A);return n.length>0&&(t.A={},n.forEach(function(n){var r=e.A[n];switch(typeof r){case"boolean":case"number":case"string":t.A[n]=r;break;default:t.A[n]=JSON.parse(JSON.stringify(r))}})),e.C.length>0&&(t.C=e.C.map(function(e){return r(e)})),t};if(!e.isA(t))throw new Error("serialize: not an ASTy node");return JSON.stringify({ASTy:n(t)})}},{key:"unserialize",value:function(e,t){var n=function i(t){var n=e.create(t.T);return n.pos(t.L.L,t.L.C,t.L.O),"object"==typeof t.A&&Object.keys(t.A).forEach(function(e){var r=t.A[e];switch(typeof r){case"boolean":case"number":case"string":n.set(e,r);break;default:n.set(e,JSON.parse(JSON.stringify(r)))}}),"object"==typeof t.C&&t.C instanceof Array&&n.add(t.C.map(function(e){return i(e)})),n},r=JSON.parse(t);if("object"!=typeof r||"object"!=typeof r.ASTy)throw new Error("unserialize: not an ASTy JSON export");return n(r.ASTy)}}]),e}();n["default"]=o,t.exports=n["default"]},{}],5:[function(e,t,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0});var r={major:1,minor:3,micro:1,date:20150819};n["default"]=r,t.exports=n["default"]},{}],6:[function(e,t,n){"use strict";function r(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}Object.defineProperty(n,"__esModule",{value:!0});var i=function(){function e(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(t,n,r){return n&&e(t.prototype,n),r&&e(t,r),t}}(),o=function(){function e(){r(this,e)}return i(e,[{key:"walk",value:function(e){var t=arguments.length<=1||void 0===arguments[1]?"downward":arguments[1],n=function r(n,i,o){("downward"===t||"both"===t)&&e.call(null,n,i,o,"downward"),n.C.forEach(function(e){r(e,i+1,n)}),("upward"===t||"both"===t)&&e.call(null,n,i,o,"upward")};return n(this,0,null),this}}]),e}();n["default"]=o,t.exports=n["default"]},{}],7:[function(e,t,n){"use strict";function r(e){return e&&e.__esModule?e:{"default":e}}function i(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}Object.defineProperty(n,"__esModule",{value:!0});var o=function(){function e(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(t,n,r){return n&&e(t.prototype,n),r&&e(t,r),t}}(),a=e("./asty-base.js"),u=r(a),f=e("./asty-merge.js"),s=r(f),l=e("./asty-walk.js"),c=r(l),h=e("./asty-dump.js"),d=r(h),y=e("./asty-serialize.js"),p=r(y),g=e("./asty-version.js"),v=r(g),w=function(){function e(){var t=this;i(this,e),this.ASTYNode=function(){};var n=[[u["default"],"init","type","pos","set","unset","get","attrs","add","del","childs","parent"],[s["default"],"merge"],[c["default"],"walk"],[d["default"],"dump"]];return n.forEach(function(e){var n=e[0].prototype;e.slice(1).forEach(function(e){t.ASTYNode.prototype[e]=n[e]})}),this}return o(e,[{key:"version",value:function(){return v["default"]}},{key:"extend",value:function(e){for(var t in e)e.hasOwnProperty(t)&&(this.ASTYNode.prototype[t]=e[t]);return this}},{key:"create",value:function(e){return(new this.ASTYNode).init(this,e)}},{key:"isA",value:function(e){return"object"==typeof e&&e instanceof this.ASTYNode&&"boolean"==typeof e.ASTy&&e.ASTy===!0}},{key:"serialize",value:function(e){return p["default"].serialize(this,e)}},{key:"unserialize",value:function(e){return p["default"].unserialize(this,e)}}]),e}();n["default"]=w,t.exports=n["default"]},{"./asty-base.js":1,"./asty-dump.js":2,"./asty-merge.js":3,"./asty-serialize.js":4,"./asty-version.js":5,"./asty-walk.js":6}]},{},[1,2,3,4,5,6,7])(7)});
}).call(this,typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {})

},{}],2:[function(_dereq_,module,exports){
(function (global){
!function(e){if("object"==typeof exports&&"undefined"!=typeof module)module.exports=e();else if("function"==typeof define&&define.amd)define([],e);else{var t;t="undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:this,t.CacheLRU=e()}}(function(){return function e(t,n,i){function r(u,s){if(!n[u]){if(!t[u]){var l="function"==typeof _dereq_&&_dereq_;if(!s&&l)return l(u,!0);if(o)return o(u,!0);var a=new Error("Cannot find module '"+u+"'");throw a.code="MODULE_NOT_FOUND",a}var h=n[u]={exports:{}};t[u][0].call(h.exports,function(e){var n=t[u][1][e];return r(n?n:e)},h,h.exports,e,t,n,i)}return n[u].exports}for(var o="function"==typeof _dereq_&&_dereq_,u=0;u<i.length;u++)r(i[u]);return r}({1:[function(e,t,n){"use strict";function i(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}Object.defineProperty(n,"__esModule",{value:!0});var r=function(){function e(e,t){for(var n=0;n<t.length;n++){var i=t[n];i.enumerable=i.enumerable||!1,i.configurable=!0,"value"in i&&(i.writable=!0),Object.defineProperty(e,i.key,i)}}return function(t,n,i){return n&&e(t.prototype,n),i&&e(t,i),t}}(),o=function(){function e(){return i(this,e),this._index={},this._LRU={newer:null},this._MRU={older:null},this._LRU.newer=this._MRU,this._MRU.older=this._LRU,this._cur=0,this._max=1/0,this._dispose=function(){},this}return r(e,[{key:"limit",value:function(e){var t=this._max;return arguments.length>0&&(this._max=e,this._purge()),t}},{key:"dispose",value:function(e){return this._dispose=e,this}},{key:"length",value:function(){return this._cur}},{key:"keys",value:function(){return this.each(function(e,t){this.push(t)},[])}},{key:"values",value:function(){return this.each(function(e){this.push(e)},[])}},{key:"each",value:function(e,t){arguments<2&&(t=this);for(var n=0,i=this._MRU.older;i!==this._LRU;)e.call(t,i.val,i.key,n++),i=i.older;return t}},{key:"has",value:function(e){var t=this._index[e];return void 0!==t}},{key:"peek",value:function(e){var t=this._index[e];return void 0===t?void 0:t.expires<Date.now()?void this.del(t.key):t.val}},{key:"touch",value:function(e){var t=this._index[e];if(void 0===t)throw new Error("touch: no such item");return this._promote(t),this}},{key:"get",value:function(e){var t=this._index[e];return void 0===t?void 0:t.expires<Date.now()?void this.del(t.key):(this._promote(t),t.val)}},{key:"set",value:function(e,t,n){arguments.length<3&&(n=1/0),n+=Date.now();var i=this._index[e];if(void 0===i)i={older:null,newer:null,key:e,val:t,expires:n},this._index[e]=i,this._attach(i),this._cur++,this._purge();else{var r=i.val;i.val=t,this._promote(i),this._dispose.call(void 0,i.key,r,"set")}return this}},{key:"del",value:function(e){var t=this._index[e];if(void 0===t)throw new Error("del: no such item");return delete this._index[e],this._detach(t),this._cur--,this._dispose.call(void 0,e,t.val,"del"),this}},{key:"clear",value:function(){for(;this._cur>0;)this.del(this._LRU.newer.key);return this}},{key:"_purge",value:function(){for(;this._cur>this._max;)this.del(this._LRU.newer.key)}},{key:"_promote",value:function(e){this._detach(e),this._attach(e)}},{key:"_detach",value:function(e){e.older.newer=e.newer,e.newer.older=e.older,e.older=null,e.newer=null}},{key:"_attach",value:function(e){e.older=this._MRU.older,e.newer=this._MRU,e.newer.older=e,e.older.newer=e}}]),e}();n["default"]=o,t.exports=n["default"]},{}]},{},[1])(1)});
}).call(this,typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {})

},{}],3:[function(_dereq_,module,exports){
(function (global){
!function(e,n,r){"function"==typeof define&&"undefined"!=typeof define.amd?define(n,function(){return r(e)}):"object"==typeof module&&"object"==typeof module.exports?module.exports=r(e):e[n]=r(e)}("undefined"!=typeof global?global:"undefined"!=typeof window?window:this,"PEGUtil",function(){var e={};e.makeAST=function(e,n,r,t){return function(){return t.util.__makeAST.call(null,e(),n(),r(),arguments)}},e.makeUnroll=function(e,n,r,t){return function(o,u,l){if("object"!=typeof u||!(u instanceof Array))throw new t("unroll: invalid list argument for unrolling",typeof u,"Array",r(),e(),n());if("undefined"!=typeof l){"number"==typeof l&&(l=[l]);var a=[];null!==o&&a.push(o);for(var i=0;i<u.length;i++)for(var f=0;f<l.length;f++)a.push(u[i][l[f]]);return a}return null!==o&&u.unshift(o),u}};var n=function(e,n){var r=e.length,t=n-20;0>t&&(t=0);var o=n+20;o>r&&(o=r);var u=function(e){return e.charCodeAt(0).toString(16).toUpperCase()},l=function(e,n,r){return e.substr(n,r).replace(/\\/g,"\\\\").replace(/\x08/g,"\\b").replace(/\t/g,"\\t").replace(/\n/g,"\\n").replace(/\f/g,"\\f").replace(/\r/g,"\\r").replace(/[\x00-\x07\x0B\x0E\x0F]/g,function(e){return"\\x0"+u(e)}).replace(/[\x10-\x1F\x80-\xFF]/g,function(e){return"\\x"+u(e)}).replace(/[\u0100-\u0FFF]/g,function(e){return"\\u0"+u(e)}).replace(/[\u1000-\uFFFF]/g,function(e){return"\\u"+u(e)})};return{prolog:l(e,t,n-t),token:l(e,n,1),epilog:l(e,n+1,o-(n+1))}};return e.parse=function(r,t,o){if("object"!=typeof r)throw new Error("invalid parser object (not an object)");if("function"!=typeof r.parse)throw new Error('invalid parser object (no "parse" function)');if("string"!=typeof t)throw new Error("invalid input text (not a string)");if("undefined"!=typeof o&&"object"!=typeof o)throw new Error("invalid options (not an object)");"undefined"==typeof o&&(o={});var u={ast:null,error:null};try{var l;l="function"==typeof o.makeAST?o.makeAST:function(e,n,r,t){return{line:e,column:n,offset:r,args:t}};var a={util:{makeUnroll:e.makeUnroll,makeAST:e.makeAST,__makeAST:l}};"string"==typeof o.startRule&&(a.startRule=o.startRule),u.ast=r.parse(t,a),u.error=null}catch(i){u.ast=null;var f=function(e,n){return"undefined"!=typeof e?e:n};u.error={line:f(i.line,0),column:f(i.column,0),message:i.message,found:f(i.found,""),expected:f(i.expected,""),location:n(t,f(i.offset,0))}}return u},e.errorMessage=function(e,n){for(var r=e.location,t="line "+e.line+" (column "+e.column+"): ",o="",u=0;u<t.length+r.prolog.length;u++)o+="-";var l=t+r.prolog+r.token+r.epilog+"\n"+o+"^\n"+e.message+(n?"":"\n");return l},e});
}).call(this,typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {})

},{}],4:[function(_dereq_,module,exports){
"use strict";function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}Object.defineProperty(exports,"__esModule",{value:!0});var _createClass=function(){function e(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(t,n,r){return n&&e(t.prototype,n),r&&e(t,r),t}}(),ASTQAdapterASTY=function(){function e(){_classCallCheck(this,e)}return _createClass(e,null,[{key:"taste",value:function(e){return"object"==typeof e&&"boolean"==typeof e.ASTy}},{key:"getParentNode",value:function(e){return e.parent()}},{key:"getChildNodes",value:function(e){return e.childs()}},{key:"getNodeType",value:function(e){return e.type()}},{key:"getNodeAttrNames",value:function(e){return e.attrs()}},{key:"getNodeAttrValue",value:function(e,t){return e.get(t)}}]),e}();exports["default"]=ASTQAdapterASTY,module.exports=exports["default"];
},{}],5:[function(_dereq_,module,exports){
"use strict";function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}Object.defineProperty(exports,"__esModule",{value:!0});var _createClass=function(){function e(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}return function(t,r,n){return r&&e(t.prototype,r),n&&e(t,n),t}}(),ASTQAdapterMozAST=function(){function e(){_classCallCheck(this,e)}return _createClass(e,null,[{key:"taste",value:function(e){return"object"==typeof e&&null!==e&&"string"==typeof e.type&&""!==e.type}},{key:"getParentNode",value:function(e,t){if("*"!==t&&"parent"!==t)throw new Error('no such axis named "'+t+'" for walking to parent nodes');if("undefined"!=typeof e.parent)return e.parent;throw new Error("Your Mozilla SpiderMonkey AST does not support parent node traversal")}},{key:"getChildNodes",value:function(e,t){var r=this,n=[],o=function(e,t){e.hasOwnProperty(t)&&r.taste(e[t])?n.push(e[t]):e.hasOwnProperty(t)&&"object"==typeof e[t]&&e[t]instanceof Array&&e[t].forEach(function(e){r.taste(e)&&n.push(e)})};if("*"===t)for(var a in e)o(e,a);else{if("undefined"==typeof e[t])throw new Error('no such axis named "'+t+'" for walking to child nodes');o(e,t)}return n}},{key:"getNodeType",value:function(e){return e.type}},{key:"getNodeAttrNames",value:function(e){var t=[];for(var r in e)e.hasOwnProperty(r)&&"object"!=typeof e[r]&&"type"!==r&&"loc"!==r&&t.push(r);return t}},{key:"getNodeAttrValue",value:function(e,t){return e.hasOwnProperty(t)&&"object"!=typeof e[t]&&"type"!==t&&"loc"!==t?e[t]:void 0}}]),e}();exports["default"]=ASTQAdapterMozAST,module.exports=exports["default"];
},{}],6:[function(_dereq_,module,exports){
"use strict";function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}Object.defineProperty(exports,"__esModule",{value:!0});var _createClass=function(){function e(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(t,n,r){return n&&e(t.prototype,n),r&&e(t,r),t}}(),ASTQAdapterXMLDOM=function(){function e(){_classCallCheck(this,e)}return _createClass(e,null,[{key:"taste",value:function(e){return"object"==typeof Node&&e instanceof Node&&"object"==typeof e&&"number"==typeof e.nodeType&&"string"==typeof e.nodeName}},{key:"getParentNode",value:function(e){return e.parentNode}},{key:"getChildNodes",value:function(e){return e.childNodes}},{key:"getNodeType",value:function(e){return e.nodeName}},{key:"getNodeAttrNames",value:function(e){return Array.prototype.slice.call(e.attributes,0).map(function(e){return e.nodeName})}},{key:"getNodeAttrValue",value:function(e,t){return e.getAttribute(t)}}]),e}();exports["default"]=ASTQAdapterXMLDOM,module.exports=exports["default"];
},{}],7:[function(_dereq_,module,exports){
"use strict";function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}Object.defineProperty(exports,"__esModule",{value:!0});var _createClass=function(){function e(e,t){for(var r=0;r<t.length;r++){var a=t[r];a.enumerable=a.enumerable||!1,a.configurable=!0,"value"in a&&(a.writable=!0),Object.defineProperty(e,a.key,a)}}return function(t,r,a){return r&&e(t.prototype,r),a&&e(t,a),t}}(),ASTQAdapter=function(){function e(){return _classCallCheck(this,e),this._adapters=[],this}return _createClass(e,[{key:"register",value:function(e){return this._adapters.unshift(e),this}},{key:"unregister",value:function(e){if(void 0===e)this._adapters=[];else{for(var t=[],r=0;r<this._adapters.length;r++)this._adapters[r]!==e&&t.push(this._adapters[r]);this._adapters=t}return this}},{key:"select",value:function(e){for(var t=0;t<this._adapters.length;t++)if(this._adapters[t].taste(e))return this._adapters[t];return void 0}}]),e}();exports["default"]=ASTQAdapter,module.exports=exports["default"];
},{}],8:[function(_dereq_,module,exports){
"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var _pos=function(t,e){var n=t.getParentNode(e,"*");if(null===n)return 1;for(var r=t.getChildNodes(n,"*"),o=0;o<r.length;o++)if(r[o]===e)return o+1;throw new Error("cannot find myself")},parents=function t(e,n){for(var t=[];null!==(n=e.getParentNode(n,"*"));)t.push(n);return t},stdfuncs={type:function(t,e){return t.getNodeType(e)},depth:function e(t,n){for(var e=1,r=n;null!==(r=t.getParentNode(r,"*"));)e++;return e},pos:function(t,e){return _pos(t,e)},nth:function(t,e,n){n=parseInt(n,10);var r=t.getParentNode(e,"*");if(null!==r){var o=t.getChildNodes(r,"*");0>n&&(n=o.length-(n+1));for(var u=0;u<o.length;u++)if(o[u]===e)return u+1===n;return!1}return 1===n?!0:!1},first:function(t,e){return stdfuncs.nth(t,e,1)},last:function(t,e){return stdfuncs.nth(t,e,-1)},count:function(t,e,n){return"object"==typeof n&&n instanceof Array?n.length:"object"==typeof n?Object.keys(n).length:"string"==typeof n?n.length:String(n).length},below:function(t,e,n){if(!t.taste(n))throw new Error('invalid argument to function "below" (node expected)');for(var r=e;null!==(r=t.getParentNode(r,"*"));)if(r===n)return!0;return!1},follows:function(t,e,n){if(!t.taste(n))throw new Error('invalid argument to function "follows" (node expected)');if(e===n)return!1;var r=[e].concat(parents(t,e)).reverse(),o=[n].concat(parents(t,n)).reverse(),u=Math.min(r.length,o.length),f=void 0;for(f=0;u>f&&r[f]===o[f];f++);if(0===f)throw new Error("internal error: root nodes have to be same same");return f===u?o.length<r.length?!0:!1:_pos(t,r[f])>_pos(t,o[f])},"in":function(t,e,n){if(!("object"==typeof n&&n instanceof Array))throw new Error('invalid argument to function "in" (array expected)');for(var r=0;r<n.length;r++)if(n[r]===e)return!0;return!1},substr:function(t,e,n,r,o){return String(n).substr(r,o)},lc:function(t,e,n){return String(n).toLowerCase()},uc:function(t,e,n){return String(n).toUpperCase()}};exports["default"]=stdfuncs,module.exports=exports["default"];
},{}],9:[function(_dereq_,module,exports){
"use strict";function _classCallCheck(e,n){if(!(e instanceof n))throw new TypeError("Cannot call a class as a function")}Object.defineProperty(exports,"__esModule",{value:!0});var _createClass=function(){function e(e,n){for(var t=0;t<n.length;t++){var r=n[t];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(n,t,r){return t&&e(n.prototype,t),r&&e(n,r),n}}(),ASTQFuncs=function(){function e(){return _classCallCheck(this,e),this._funcs={},this}return _createClass(e,[{key:"register",value:function(e,n){this._funcs[e]=n}},{key:"run",value:function(e,n){var t=this._funcs[e];if("function"!=typeof t)throw new Error('invalid function "'+e+'"');return t.apply(null,n)}}]),e}();exports["default"]=ASTQFuncs,module.exports=exports["default"];
},{}],10:[function(_dereq_,module,exports){
"use strict";function _interopRequireDefault(e){return e&&e.__esModule?e:{"default":e}}function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function _inherits(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)}Object.defineProperty(exports,"__esModule",{value:!0});var _createClass=function(){function e(e,t){for(var r=0;r<t.length;r++){var a=t[r];a.enumerable=a.enumerable||!1,a.configurable=!0,"value"in a&&(a.writable=!0),Object.defineProperty(e,a.key,a)}}return function(t,r,a){return r&&e(t.prototype,r),a&&e(t,a),t}}(),_get=function(e,t,r){for(var a=!0;a;){var i=e,n=t,c=r;s=u=l=void 0,a=!1,null===i&&(i=Function.prototype);var s=Object.getOwnPropertyDescriptor(i,n);if(void 0!==s){if("value"in s)return s.value;var l=s.get;return void 0===l?void 0:l.call(c)}var u=Object.getPrototypeOf(i);if(null===u)return void 0;e=u,t=n,r=c,a=!0}},_astqUtilJs=_dereq_("./astq-util.js"),_astqUtilJs2=_interopRequireDefault(_astqUtilJs),_astqQueryTraceJs=_dereq_("./astq-query-trace.js"),_astqQueryTraceJs2=_interopRequireDefault(_astqQueryTraceJs),ASTQQueryExec=function(e){function t(e,r,a,i){_classCallCheck(this,t),_get(Object.getPrototypeOf(t.prototype),"constructor",this).call(this),this.adapter=e,this.params=r,this.funcs=a,this.trace=i}return _inherits(t,e),_createClass(t,[{key:"execQuery",value:function(e,t){var r=this;this.traceBegin(e,t);var a=[];return e.childs().forEach(function(e){a=a.concat(r.execPath(e,t))}),this.traceEnd(e,t,a),a}},{key:"execPath",value:function(e,t){var r=this;this.traceBegin(e,t);var a=[t];return e.childs().forEach(function(e){var t=[];a.forEach(function(a){t=t.concat(r.execStep(e,a))}),a=t}),this.traceEnd(e,t,a),a}},{key:"execStep",value:function(e,t){var r=this;this.traceBegin(e,t);var a=e.childs(),i=null,n=null,c=null,s=0;if(s<a.length&&"Axis"===a[s].type()&&(i=a[s++]),s<a.length&&"Match"===a[s].type()&&(n=a[s++]),s<a.length&&"Filter"===a[s].type()&&(c=a[s++]),null===n)throw new Error("no matching part in query step");var l=[],u=n.get("id"),o=function(e){var t=r.adapter.getNodeType(e);if("*"===u||u===t){var a=!0;null!==c&&(r.execFilter(c,e)||(a=!1)),a&&l.push(e)}};return null!==i?!function(){var e=i.get("op"),a=i.get("type");if("/"===e)r.adapter.getChildNodes(t,a).forEach(function(e){return o(e)});else if("//"===e)!function(){var e=function i(e){o(e),r.adapter.getChildNodes(e,a).forEach(function(e){return i(e)})};r.adapter.getChildNodes(t,a).forEach(function(t){return e(t)})}();else if("-/"===e){var n=r.adapter.getParentNode(t,"*");if(null!==n){for(var c=r.adapter.getChildNodes(n,a),s=null,u=0;u<c.length&&c[u]!==t;u++)s=c[u];null!==s&&o(s)}}else if("-//"===e){var h=r.adapter.getParentNode(t,"*");if(null!==h){for(var c=r.adapter.getChildNodes(h,a),d=0;d<c.length&&c[d]!==t;d++);for(d--;d>=0;d--)o(c[d])}}else if("+/"===e){var f=r.adapter.getParentNode(t,"*");if(null!==f){var c=r.adapter.getChildNodes(f,a),p=void 0;for(p=0;p<c.length&&c[p]!==t;p++);p<c.length&&o(c[++p])}}else if("+//"===e){var x=r.adapter.getParentNode(t,"*");if(null!==x){var c=r.adapter.getChildNodes(x,a),v=void 0;for(v=0;v<c.length&&c[v]!==t;v++);if(v<c.length)for(v++;v<c.length;v++)o(c[v])}}else if("../"===e){var g=r.adapter.getParentNode(t,a);null!==g&&o(g)}else if("..//"===e)for(var E=t;;){var y=r.adapter.getParentNode(E,a);if(null===y)break;o(y),E=y}else"<//"===e?!function(){for(var e={sentinel:t,take:!0};;){var i=r.adapter.getParentNode(t,"*");if(null===i)break;t=i}var n=function c(t){t===e.sentinel&&(e.take=!1),e.take&&o(t),e.take&&r.adapter.getChildNodes(t,a).forEach(function(e){return c(e)})};t!==e.sentinel&&(o(t),r.adapter.getChildNodes(t,a).forEach(function(e){return n(e)})),l=l.reverse()}():">//"===e&&!function(){for(var e={sentinel:t,take:!1};;){var i=r.adapter.getParentNode(t,"*");if(null===i)break;t=i}var n=function c(t){e.take&&o(t),t===e.sentinel&&(e.take=!0),r.adapter.getChildNodes(t,a).forEach(function(e){return c(e)})};r.adapter.getChildNodes(t,a).forEach(function(e){return n(e)})}()}():o(t),this.traceEnd(e,t,l),l}},{key:"execFilter",value:function(e,t){this.traceBegin(e,t);var r=e.childs()[0],a=this.execExpr(r,t);return a=_astqUtilJs2["default"].truthy(a),this.traceEnd(e,t,a),a}},{key:"execExpr",value:function(e,t){switch(e.type()){case"ConditionalBinary":return this.execExprConditionalBinary(e,t);case"ConditionalTernary":return this.execExprConditionalTernary(e,t);case"Logical":return this.execExprLogical(e,t);case"Bitwise":return this.execExprBitwise(e,t);case"Relational":return this.execExprRelational(e,t);case"Arithmetical":return this.execExprArithmetical(e,t);case"Unary":return this.execExprUnary(e,t);case"FuncCall":return this.execExprFuncCall(e,t);case"Attribute":return this.execExprAttribute(e,t);case"Param":return this.execExprParam(e,t);case"LiteralString":return this.execExprLiteralString(e,t);case"LiteralRegExp":return this.execExprLiteralRegExp(e,t);case"LiteralNumber":return this.execExprLiteralNumber(e,t);case"LiteralValue":return this.execExprLiteralValue(e,t);case"Path":return this.execExprPath(e,t)}}},{key:"execExprConditionalBinary",value:function(e,t){this.traceBegin(e,t);var r=this.execExpr(e.childs()[0],t);return _astqUtilJs2["default"].truthy(r)||(r=this.execExpr(e.childs()[1],t)),this.traceEnd(e,t,r),r}},{key:"execExprConditionalTernary",value:function(e,t){this.traceBegin(e,t);var r=this.execExpr(e.childs()[0],t);return r=_astqUtilJs2["default"].truthy(r)?this.execExpr(e.childs()[1],t):this.execExpr(e.childs()[2],t),this.traceEnd(e,t,r),r}},{key:"execExprLogical",value:function(e,t){this.traceBegin(e,t);var r=!1;switch(e.get("op")){case"&&":r=_astqUtilJs2["default"].truthy(this.execExpr(e.childs()[0],t)),r&&(r=r&&_astqUtilJs2["default"].truthy(this.execExpr(e.childs()[1],t)));break;case"||":r=_astqUtilJs2["default"].truthy(this.execExpr(e.childs()[0],t)),r||(r=r||_astqUtilJs2["default"].truthy(this.execExpr(e.childs()[1],t)))}return this.traceEnd(e,t,r),r}},{key:"execExprBitwise",value:function(e,t){this.traceBegin(e,t);var r=_astqUtilJs2["default"].coerce(this.execExpr(e.childs()[0],t),"number"),a=_astqUtilJs2["default"].coerce(this.execExpr(e.childs()[1],t),"number"),i=void 0;switch(e.get("op")){case"&":i=r&a;break;case"|":i=r|a;break;case"<<":i=r<<a;break;case">>":i=r>>a}return this.traceEnd(e,t,i),i}},{key:"execExprRelational",value:function(e,t){this.traceBegin(e,t);var r=this.execExpr(e.childs()[0],t),a=this.execExpr(e.childs()[1],t),i=void 0;switch(e.get("op")){case"==":i=r===a;break;case"!=":i=r!==a;break;case"<=":i=_astqUtilJs2["default"].coerce(r,"number")<=_astqUtilJs2["default"].coerce(a,"number");break;case">=":i=_astqUtilJs2["default"].coerce(r,"number")>=_astqUtilJs2["default"].coerce(a,"number");break;case"<":i=_astqUtilJs2["default"].coerce(r,"number")<_astqUtilJs2["default"].coerce(a,"number");break;case">":i=_astqUtilJs2["default"].coerce(r,"number")>_astqUtilJs2["default"].coerce(a,"number");break;case"=~":i=null!==_astqUtilJs2["default"].coerce(r,"string").match(_astqUtilJs2["default"].coerce(a,"regexp"));break;case"!~":i=null===_astqUtilJs2["default"].coerce(r,"string").match(_astqUtilJs2["default"].coerce(a,"regexp"))}return this.traceEnd(e,t,i),i}},{key:"execExprArithmetical",value:function(e,t){this.traceBegin(e,t);var r=this.execExpr(e.childs()[0],t),a=this.execExpr(e.childs()[1],t),i=void 0;switch(e.get("op")){case"+":i="string"==typeof r?r+_astqUtilJs2["default"].coerce(a,"string"):_astqUtilJs2["default"].coerce(r,"number")+_astqUtilJs2["default"].coerce(a,"number");break;case"-":i=_astqUtilJs2["default"].coerce(r,"number")+_astqUtilJs2["default"].coerce(a,"number");break;case"*":i=_astqUtilJs2["default"].coerce(r,"number")*_astqUtilJs2["default"].coerce(a,"number");break;case"/":i=_astqUtilJs2["default"].coerce(r,"number")/_astqUtilJs2["default"].coerce(a,"number");break;case"%":i=_astqUtilJs2["default"].coerce(r,"number")%_astqUtilJs2["default"].coerce(a,"number");break;case"**":i=Math.pow(_astqUtilJs2["default"].coerce(r,"number"),_astqUtilJs2["default"].coerce(a,"number"))}return this.traceEnd(e,t,i),i}},{key:"execExprUnary",value:function(e,t){this.traceBegin(e,t);var r=this.execExpr(e.childs()[0],t),a=void 0;switch(e.get("op")){case"!":a=!_astqUtilJs2["default"].coerce(r,"boolean");break;case"~":a=~_astqUtilJs2["default"].coerce(r,"number")}return this.traceEnd(e,t,a),a}},{key:"execExprFuncCall",value:function(e,t){var r=this;this.traceBegin(e,t);var a=e.get("id"),i=[this.adapter,t];e.childs().forEach(function(e){i.push(r.execExpr(e,t))});var n=this.funcs.run(a,i);return this.traceEnd(e,t,n),n}},{key:"execExprAttribute",value:function(e,t){this.traceBegin(e,t);var r=e.get("id"),a=this.adapter.getNodeAttrValue(t,r);return this.traceEnd(e,t,a),a}},{key:"execExprParam",value:function(e,t){this.traceBegin(e,t);var r=e.get("id");if("undefined"==typeof this.params[r])throw new Error('invalid parameter "'+r+'"');var a=this.params[r];return this.traceEnd(e,t,a),a}},{key:"execExprLiteralString",value:function(e,t){this.traceBegin(e,t);var r=e.get("value");return this.traceEnd(e,t,r),r}},{key:"execExprLiteralRegExp",value:function(e,t){this.traceBegin(e,t);var r=e.get("value");return this.traceEnd(e,t,r),r}},{key:"execExprLiteralNumber",value:function(e,t){this.traceBegin(e,t);var r=e.get("value");return this.traceEnd(e,t,r),r}},{key:"execExprLiteralValue",value:function(e,t){this.traceBegin(e,t);var r=e.get("value");return this.traceEnd(e,t,r),r}},{key:"execExprPath",value:function(e,t){this.traceBegin(e,t);var r=this.execPath(e,t);return this.traceEnd(e,t,r),r}}]),t}(_astqQueryTraceJs2["default"]);exports["default"]=ASTQQueryExec,module.exports=exports["default"];
},{"./astq-query-trace.js":11,"./astq-util.js":13}],11:[function(_dereq_,module,exports){
"use strict";function _interopRequireDefault(e){return e&&e.__esModule?e:{"default":e}}function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}Object.defineProperty(exports,"__esModule",{value:!0});var _createClass=function(){function e(e,t){for(var r=0;r<t.length;r++){var a=t[r];a.enumerable=a.enumerable||!1,a.configurable=!0,"value"in a&&(a.writable=!0),Object.defineProperty(e,a.key,a)}}return function(t,r,a){return r&&e(t.prototype,r),a&&e(t,a),t}}(),_astqUtilJs=_dereq_("./astq-util.js"),_astqUtilJs2=_interopRequireDefault(_astqUtilJs),ASTQQueryTrace=function(){function e(){_classCallCheck(this,e)}return _createClass(e,[{key:"prefixOf",value:function(e,t){for(var r=0,a=e;null!==(a=a.parent());)r++;var i=_astqUtilJs2["default"].pad("",4*r);for(r=0,a=t;null!==(a=this.adapter.getParentNode(a,"*"));)r++;var n=_astqUtilJs2["default"].pad("",4*r);return{prefix1:i,prefix2:n}}},{key:"traceBegin",value:function(e,t){if(this.trace){var r=this.prefixOf(e,t),a=r.prefix1,i=r.prefix2;console.log("ASTQ: execute: | "+_astqUtilJs2["default"].pad(a+e.type()+" (",-60)+" | "+i+this.adapter.getNodeType(t))}}},{key:"traceEnd",value:function(e,t,r){var a=this;if(this.trace){var i=this.prefixOf(e,t),n=i.prefix1,l=i.prefix2,o=void 0;void 0===r?o="undefined":"object"==typeof r&&r instanceof Array?(o="[",r.forEach(function(e){o+="node("+a.adapter.getNodeType(e)+"),"}),o=o.replace(/,$/,"")+"]"):o=typeof r+"("+r+")",o.length>60&&(o=o.substr(0,60)+"..."),console.log("ASTQ: execute: | "+_astqUtilJs2["default"].pad(n+"): "+o,-60)+" | "+l+this.adapter.getNodeType(t))}}}]),e}();exports["default"]=ASTQQueryTrace,module.exports=exports["default"];
},{"./astq-util.js":13}],12:[function(_dereq_,module,exports){
"use strict";function _interopRequireDefault(t){return t&&t.__esModule?t:{"default":t}}function _classCallCheck(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}Object.defineProperty(exports,"__esModule",{value:!0});var _createClass=function(){function t(t,e){for(var r=0;r<e.length;r++){var n=e[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(t,n.key,n)}}return function(e,r,n){return r&&t(e.prototype,r),n&&t(e,n),e}}(),_astqQueryExecJs=_dereq_("./astq-query-exec.js"),_astqQueryExecJs2=_interopRequireDefault(_astqQueryExecJs),ASTY=_dereq_("asty"),PEGUtil=_dereq_("pegjs-util"),ASTQQueryParse=function(){function t(t,e){function r(){this.constructor=t}r.prototype=e.prototype,t.prototype=new r}function e(t,e,r,n,s,u){this.message=t,this.expected=e,this.found=r,this.offset=n,this.line=s,this.column=u,this.name="SyntaxError"}function r(t){function r(){return cs}function n(){return i(cs).line}function s(){return i(cs).column}function u(t){throw l(t,null,cs)}function i(e){function r(e,r,n){var s,u;for(s=r;n>s;s++)u=t.charAt(s),"\n"===u?(e.seenCR||e.line++,e.column=1,e.seenCR=!1):"\r"===u||"\u2028"===u||"\u2029"===u?(e.line++,e.column=1,e.seenCR=!0):(e.column++,e.seenCR=!1)}return ps!==e&&(ps>e&&(ps=0,fs={line:1,column:1,seenCR:!1}),r(fs,ps,e),ps=e),fs}function a(t){ds>os||(os>ds&&(ds=os,hs=[]),hs.push(t))}function l(r,n,s){function u(t){var e=1;for(t.sort(function(t,e){return t.description<e.description?-1:t.description>e.description?1:0});e<t.length;)t[e-1]===t[e]?t.splice(e,1):e++}function a(t,e){function r(t){function e(t){return t.charCodeAt(0).toString(16).toUpperCase()}return t.replace(/\\/g,"\\\\").replace(/"/g,'\\"').replace(/\x08/g,"\\b").replace(/\t/g,"\\t").replace(/\n/g,"\\n").replace(/\f/g,"\\f").replace(/\r/g,"\\r").replace(/[\x00-\x07\x0B\x0E\x0F]/g,function(t){return"\\x0"+e(t)}).replace(/[\x10-\x1F\x80-\xFF]/g,function(t){return"\\x"+e(t)}).replace(/[\u0180-\u0FFF]/g,function(t){return"\\u0"+e(t)}).replace(/[\u1080-\uFFFF]/g,function(t){return"\\u"+e(t)})}var n,s,u,i=new Array(t.length);for(u=0;u<t.length;u++)i[u]=t[u].description;return n=t.length>1?i.slice(0,-1).join(", ")+" or "+i[t.length-1]:i[0],s=e?'"'+r(e)+'"':"end of input","Expected "+n+" but "+s+" found."}var l=i(s),o=s<t.length?t.charAt(s):null;return null!==n&&u(n),new e(null!==r?r:a(n,o),n,o,s,l.line,l.column)}function o(){var t,e,r,n,s,u=37*os+0,i=As[u];return i?(os=i.nextPos,i.result):(t=os,e=V(),e!==Y?(r=c(),r!==Y?(n=V(),n!==Y?(s=G(),s!==Y?(cs=t,e=W(r),t=e):(os=t,t=K)):(os=t,t=K)):(os=t,t=K)):(os=t,t=K),As[u]={nextPos:os,result:t},t)}function c(){var e,r,n,s,u,i,l,o,c=37*os+1,f=As[c];if(f)return os=f.nextPos,f.result;if(e=os,r=p(),r!==Y){for(n=[],s=os,u=V(),u!==Y?(44===t.charCodeAt(os)?(i=X,os++):(i=Y,0===vs&&a(tt)),i!==Y?(l=V(),l!==Y?(o=p(),o!==Y?(u=[u,i,l,o],s=u):(os=s,s=K)):(os=s,s=K)):(os=s,s=K)):(os=s,s=K);s!==Y;)n.push(s),s=os,u=V(),u!==Y?(44===t.charCodeAt(os)?(i=X,os++):(i=Y,0===vs&&a(tt)),i!==Y?(l=V(),l!==Y?(o=p(),o!==Y?(u=[u,i,l,o],s=u):(os=s,s=K)):(os=s,s=K)):(os=s,s=K)):(os=s,s=K);n!==Y?(cs=e,r=et(r,n),e=r):(os=e,e=K)}else os=e,e=K;return As[c]={nextPos:os,result:e},e}function p(){var t,e,r,n,s,u,i=37*os+2,a=As[i];if(a)return os=a.nextPos,a.result;if(t=os,e=f(),e!==Y){for(r=[],n=os,s=V(),s!==Y?(u=d(),u!==Y?(s=[s,u],n=s):(os=n,n=K)):(os=n,n=K);n!==Y;)r.push(n),n=os,s=V(),s!==Y?(u=d(),u!==Y?(s=[s,u],n=s):(os=n,n=K)):(os=n,n=K);r!==Y?(cs=t,e=rt(e,r),t=e):(os=t,t=K)}else os=t,t=K;return As[i]={nextPos:os,result:t},t}function f(){var t,e,r,n,s,u,i=37*os+3,a=As[i];return a?(os=a.nextPos,a.result):(t=os,e=h(),e===Y&&(e=nt),e!==Y?(r=V(),r!==Y?(n=A(),n!==Y?(s=V(),s!==Y?(u=y(),u===Y&&(u=nt),u!==Y?(cs=t,e=st(e,n,u),t=e):(os=t,t=K)):(os=t,t=K)):(os=t,t=K)):(os=t,t=K)):(os=t,t=K),As[i]={nextPos:os,result:t},t)}function d(){var t,e,r,n,s,u,i=37*os+4,a=As[i];return a?(os=a.nextPos,a.result):(t=os,e=h(),e!==Y?(r=V(),r!==Y?(n=A(),n!==Y?(s=V(),s!==Y?(u=y(),u===Y&&(u=nt),u!==Y?(cs=t,e=st(e,n,u),t=e):(os=t,t=K)):(os=t,t=K)):(os=t,t=K)):(os=t,t=K)):(os=t,t=K),As[i]={nextPos:os,result:t},t)}function h(){var e,r,n,s=37*os+5,u=As[s];return u?(os=u.nextPos,u.result):(vs++,e=os,r=os,t.substr(os,2)===it?(n=it,os+=2):(n=Y,0===vs&&a(at)),n===Y&&(47===t.charCodeAt(os)?(n=lt,os++):(n=Y,0===vs&&a(ot)),n===Y&&(t.substr(os,3)===ct?(n=ct,os+=3):(n=Y,0===vs&&a(pt)),n===Y&&(t.substr(os,2)===ft?(n=ft,os+=2):(n=Y,0===vs&&a(dt)),n===Y&&(t.substr(os,3)===ht?(n=ht,os+=3):(n=Y,0===vs&&a(vt)),n===Y&&(t.substr(os,2)===At?(n=At,os+=2):(n=Y,0===vs&&a(yt)),n===Y&&(t.substr(os,4)===xt?(n=xt,os+=4):(n=Y,0===vs&&a(bt)),n===Y&&(t.substr(os,3)===Pt?(n=Pt,os+=3):(n=Y,0===vs&&a(gt)),n===Y&&(t.substr(os,3)===Ct?(n=Ct,os+=3):(n=Y,0===vs&&a(mt)),n===Y&&(t.substr(os,3)===Et?(n=Et,os+=3):(n=Y,0===vs&&a(St))))))))))),n!==Y&&(n=t.substring(r,os)),r=n,r!==Y?(n=v(),n===Y&&(n=nt),n!==Y?(cs=e,r=Qt(r,n),e=r):(os=e,e=K)):(os=e,e=K),vs--,e===Y&&(r=Y,0===vs&&a(ut)),As[s]={nextPos:os,result:e},e)}function v(){var e,r,n,s,u=37*os+6,i=As[u];return i?(os=i.nextPos,i.result):(e=os,58===t.charCodeAt(os)?(r=_t,os++):(r=Y,0===vs&&a(Rt)),r!==Y?(n=os,s=j(),s!==Y&&(s=t.substring(n,os)),n=s,n!==Y?(cs=e,r=wt(n),e=r):(os=e,e=K)):(os=e,e=K),As[u]={nextPos:os,result:e},e)}function A(){var e,r,n=37*os+7,s=As[n];return s?(os=s.nextPos,s.result):(e=os,r=j(),r!==Y&&(cs=e,r=Ft(r)),e=r,e===Y&&(e=os,42===t.charCodeAt(os)?(r=qt,os++):(r=Y,0===vs&&a(Tt)),r!==Y&&(cs=e,r=Lt()),e=r),As[n]={nextPos:os,result:e},e)}function y(){var e,r,n,s,u,i,l=37*os+8,o=As[l];return o?(os=o.nextPos,o.result):(e=os,91===t.charCodeAt(os)?(r=Nt,os++):(r=Y,0===vs&&a(kt)),r!==Y?(n=V(),n!==Y?(s=x(),s!==Y?(u=V(),u!==Y?(93===t.charCodeAt(os)?(i=jt,os++):(i=Y,0===vs&&a(zt)),i!==Y?(cs=e,r=It(s),e=r):(os=e,e=K)):(os=e,e=K)):(os=e,e=K)):(os=e,e=K)):(os=e,e=K),As[l]={nextPos:os,result:e},e)}function x(){var e,r,n,s,u,i,l,o,c,p,f=37*os+9,d=As[f];return d?(os=d.nextPos,d.result):(e=os,r=b(),r!==Y?(n=V(),n!==Y?(t.substr(os,2)===Ut?(s=Ut,os+=2):(s=Y,0===vs&&a(Zt)),s!==Y?(u=V(),u!==Y?(i=b(),i!==Y?(cs=e,r=Mt(r,i),e=r):(os=e,e=K)):(os=e,e=K)):(os=e,e=K)):(os=e,e=K)):(os=e,e=K),e===Y&&(e=os,r=b(),r!==Y?(n=V(),n!==Y?(63===t.charCodeAt(os)?(s=Vt,os++):(s=Y,0===vs&&a(Jt)),s!==Y?(u=V(),u!==Y?(i=b(),i!==Y?(l=V(),l!==Y?(58===t.charCodeAt(os)?(o=_t,os++):(o=Y,0===vs&&a(Rt)),o!==Y?(c=V(),c!==Y?(p=b(),p!==Y?(cs=e,r=Bt(r,i,p),e=r):(os=e,e=K)):(os=e,e=K)):(os=e,e=K)):(os=e,e=K)):(os=e,e=K)):(os=e,e=K)):(os=e,e=K)):(os=e,e=K)):(os=e,e=K),e===Y&&(e=b())),As[f]={nextPos:os,result:e},e)}function b(){var e,r,n,s,u,i,l=37*os+10,o=As[l];return o?(os=o.nextPos,o.result):(e=os,r=P(),r!==Y?(n=V(),n!==Y?(s=os,t.substr(os,2)===Gt?(u=Gt,os+=2):(u=Y,0===vs&&a(Ot)),u!==Y&&(u=t.substring(s,os)),s=u,s!==Y?(u=V(),u!==Y?(i=b(),i!==Y?(cs=e,r=Dt(r,s,i),e=r):(os=e,e=K)):(os=e,e=K)):(os=e,e=K)):(os=e,e=K)):(os=e,e=K),e===Y&&(e=P()),As[l]={nextPos:os,result:e},e)}function P(){var e,r,n,s,u,i,l=37*os+11,o=As[l];return o?(os=o.nextPos,o.result):(e=os,r=g(),r!==Y?(n=V(),n!==Y?(s=os,t.substr(os,2)===Yt?(u=Yt,os+=2):(u=Y,0===vs&&a($t)),u!==Y&&(u=t.substring(s,os)),s=u,s!==Y?(u=V(),u!==Y?(i=P(),i!==Y?(cs=e,r=Dt(r,s,i),e=r):(os=e,e=K)):(os=e,e=K)):(os=e,e=K)):(os=e,e=K)):(os=e,e=K),e===Y&&(e=g()),As[l]={nextPos:os,result:e},e)}function g(){var e,r,n,s,u,i,l=37*os+12,o=As[l];return o?(os=o.nextPos,o.result):(e=os,r=C(),r!==Y?(n=V(),n!==Y?(s=os,124===t.charCodeAt(os)?(u=Ht,os++):(u=Y,0===vs&&a(Kt)),u!==Y&&(u=t.substring(s,os)),s=u,s!==Y?(u=V(),u!==Y?(i=g(),i!==Y?(cs=e,r=Wt(r,s,i),e=r):(os=e,e=K)):(os=e,e=K)):(os=e,e=K)):(os=e,e=K)):(os=e,e=K),e===Y&&(e=C()),As[l]={nextPos:os,result:e},e)}function C(){var e,r,n,s,u,i,l=37*os+13,o=As[l];return o?(os=o.nextPos,o.result):(e=os,r=m(),r!==Y?(n=V(),n!==Y?(s=os,94===t.charCodeAt(os)?(u=Xt,os++):(u=Y,0===vs&&a(te)),u!==Y&&(u=t.substring(s,os)),s=u,s!==Y?(u=V(),u!==Y?(i=C(),i!==Y?(cs=e,r=Wt(r,s,i),e=r):(os=e,e=K)):(os=e,e=K)):(os=e,e=K)):(os=e,e=K)):(os=e,e=K),e===Y&&(e=m()),As[l]={nextPos:os,result:e},e)}function m(){var e,r,n,s,u,i,l=37*os+14,o=As[l];return o?(os=o.nextPos,o.result):(e=os,r=E(),r!==Y?(n=V(),n!==Y?(s=os,38===t.charCodeAt(os)?(u=ee,os++):(u=Y,0===vs&&a(re)),u!==Y&&(u=t.substring(s,os)),s=u,s!==Y?(u=V(),u!==Y?(i=m(),i!==Y?(cs=e,r=Wt(r,s,i),e=r):(os=e,e=K)):(os=e,e=K)):(os=e,e=K)):(os=e,e=K)):(os=e,e=K),e===Y&&(e=E()),As[l]={nextPos:os,result:e},e)}function E(){var e,r,n,s,u,i,l=37*os+15,o=As[l];return o?(os=o.nextPos,o.result):(e=os,r=S(),r!==Y?(n=V(),n!==Y?(s=os,t.substr(os,2)===ne?(u=ne,os+=2):(u=Y,0===vs&&a(se)),u===Y&&(t.substr(os,2)===ue?(u=ue,os+=2):(u=Y,0===vs&&a(ie)),u===Y&&(t.substr(os,2)===ae?(u=ae,os+=2):(u=Y,0===vs&&a(le)),u===Y&&(t.substr(os,2)===oe?(u=oe,os+=2):(u=Y,0===vs&&a(ce)),u===Y&&(60===t.charCodeAt(os)?(u=pe,os++):(u=Y,0===vs&&a(fe)),u===Y&&(62===t.charCodeAt(os)?(u=de,os++):(u=Y,0===vs&&a(he)),u===Y&&(t.substr(os,2)===ve?(u=ve,os+=2):(u=Y,0===vs&&a(Ae)),u===Y&&(t.substr(os,2)===ye?(u=ye,os+=2):(u=Y,0===vs&&a(xe))))))))),u!==Y&&(u=t.substring(s,os)),s=u,s!==Y?(u=V(),u!==Y?(i=E(),i!==Y?(cs=e,r=be(r,s,i),e=r):(os=e,e=K)):(os=e,e=K)):(os=e,e=K)):(os=e,e=K)):(os=e,e=K),e===Y&&(e=S()),As[l]={nextPos:os,result:e},e)}function S(){var e,r,n,s,u,i,l=37*os+16,o=As[l];return o?(os=o.nextPos,o.result):(e=os,r=Q(),r!==Y?(n=V(),n!==Y?(s=os,t.substr(os,2)===Pe?(u=Pe,os+=2):(u=Y,0===vs&&a(ge)),u===Y&&(t.substr(os,2)===Ce?(u=Ce,os+=2):(u=Y,0===vs&&a(me))),u!==Y&&(u=t.substring(s,os)),s=u,s!==Y?(u=V(),u!==Y?(i=S(),i!==Y?(cs=e,r=Wt(r,s,i),e=r):(os=e,e=K)):(os=e,e=K)):(os=e,e=K)):(os=e,e=K)):(os=e,e=K),e===Y&&(e=Q()),As[l]={nextPos:os,result:e},e)}function Q(){var e,r,n,s,u,i,l=37*os+17,o=As[l];return o?(os=o.nextPos,o.result):(e=os,r=_(),r!==Y?(n=V(),n!==Y?(s=os,43===t.charCodeAt(os)?(u=Ee,os++):(u=Y,0===vs&&a(Se)),u===Y&&(45===t.charCodeAt(os)?(u=Qe,os++):(u=Y,0===vs&&a(_e))),u!==Y&&(u=t.substring(s,os)),s=u,s!==Y?(u=V(),u!==Y?(i=Q(),i!==Y?(cs=e,r=Re(r,s,i),e=r):(os=e,e=K)):(os=e,e=K)):(os=e,e=K)):(os=e,e=K)):(os=e,e=K),e===Y&&(e=_()),As[l]={nextPos:os,result:e},e)}function _(){var e,r,n,s,u,i,l=37*os+18,o=As[l];return o?(os=o.nextPos,o.result):(e=os,r=R(),r!==Y?(n=V(),n!==Y?(s=os,t.substr(os,2)===we?(u=we,os+=2):(u=Y,0===vs&&a(Fe)),u===Y&&(42===t.charCodeAt(os)?(u=qt,os++):(u=Y,0===vs&&a(Tt)),u===Y&&(47===t.charCodeAt(os)?(u=lt,os++):(u=Y,0===vs&&a(ot)),u===Y&&(37===t.charCodeAt(os)?(u=qe,os++):(u=Y,0===vs&&a(Te))))),u!==Y&&(u=t.substring(s,os)),s=u,s!==Y?(u=V(),u!==Y?(i=_(),i!==Y?(cs=e,r=Re(r,s,i),e=r):(os=e,e=K)):(os=e,e=K)):(os=e,e=K)):(os=e,e=K)):(os=e,e=K),e===Y&&(e=R()),As[l]={nextPos:os,result:e},e)}function R(){var e,r,n,s=37*os+19,u=As[s];return u?(os=u.nextPos,u.result):(e=os,r=os,33===t.charCodeAt(os)?(n=Le,os++):(n=Y,0===vs&&a(Ne)),n===Y&&(126===t.charCodeAt(os)?(n=ke,os++):(n=Y,0===vs&&a(je))),n!==Y&&(n=t.substring(r,os)),r=n,r!==Y?(n=w(),n!==Y?(cs=e,r=ze(r,n),e=r):(os=e,e=K)):(os=e,e=K),e===Y&&(e=w()),As[s]={nextPos:os,result:e},e)}function w(){var t,e=37*os+20,r=As[e];return r?(os=r.nextPos,r.result):(t=F(),t===Y&&(t=T(),t===Y&&(t=L(),t===Y&&(t=N(),t===Y&&(t=k(),t===Y&&(t=p()))))),As[e]={nextPos:os,result:t},t)}function F(){var e,r,n,s,u,i,l,o,c=37*os+21,p=As[c];return p?(os=p.nextPos,p.result):(e=os,r=j(),r!==Y?(n=V(),n!==Y?(40===t.charCodeAt(os)?(s=Ie,os++):(s=Y,0===vs&&a(Ue)),s!==Y?(u=V(),u!==Y?(i=q(),i===Y&&(i=nt),i!==Y?(l=V(),l!==Y?(41===t.charCodeAt(os)?(o=Ze,os++):(o=Y,0===vs&&a(Me)),o!==Y?(cs=e,r=Ve(r,i),e=r):(os=e,e=K)):(os=e,e=K)):(os=e,e=K)):(os=e,e=K)):(os=e,e=K)):(os=e,e=K)):(os=e,e=K),As[c]={nextPos:os,result:e},e)}function q(){var e,r,n,s,u,i,l,o,c=37*os+22,p=As[c];if(p)return os=p.nextPos,p.result;if(e=os,r=x(),r!==Y){for(n=[],s=os,u=V(),u!==Y?(44===t.charCodeAt(os)?(i=X,os++):(i=Y,0===vs&&a(tt)),i!==Y?(l=V(),l!==Y?(o=x(),o!==Y?(u=[u,i,l,o],s=u):(os=s,s=K)):(os=s,s=K)):(os=s,s=K)):(os=s,s=K);s!==Y;)n.push(s),s=os,u=V(),u!==Y?(44===t.charCodeAt(os)?(i=X,os++):(i=Y,0===vs&&a(tt)),i!==Y?(l=V(),l!==Y?(o=x(),o!==Y?(u=[u,i,l,o],s=u):(os=s,s=K)):(os=s,s=K)):(os=s,s=K)):(os=s,s=K);n!==Y?(cs=e,r=Je(r,n),e=r):(os=e,e=K)}else os=e,e=K;return As[c]={nextPos:os,result:e},e}function T(){var e,r,n,s=37*os+23,u=As[s];return u?(os=u.nextPos,u.result):(vs++,e=os,64===t.charCodeAt(os)?(r=Ge,os++):(r=Y,0===vs&&a(Oe)),r!==Y?(n=j(),n!==Y?(cs=e,r=De(n),e=r):(os=e,e=K)):(os=e,e=K),vs--,e===Y&&(r=Y,0===vs&&a(Be)),As[s]={nextPos:os,result:e},e)}function L(){var e,r,n,s,u,i,l=37*os+24,o=As[l];return o?(os=o.nextPos,o.result):(vs++,e=os,123===t.charCodeAt(os)?(r=$e,os++):(r=Y,0===vs&&a(He)),r!==Y?(n=V(),n!==Y?(s=j(),s!==Y?(u=V(),u!==Y?(125===t.charCodeAt(os)?(i=Ke,os++):(i=Y,0===vs&&a(We)),i!==Y?(cs=e,r=Xe(s),e=r):(os=e,e=K)):(os=e,e=K)):(os=e,e=K)):(os=e,e=K)):(os=e,e=K),vs--,e===Y&&(r=Y,0===vs&&a(Ye)),As[l]={nextPos:os,result:e},e)}function N(){var t,e=37*os+25,r=As[e];return r?(os=r.nextPos,r.result):(t=z(),t===Y&&(t=U(),t===Y&&(t=Z(),t===Y&&(t=M()))),As[e]={nextPos:os,result:t},t)}function k(){var e,r,n,s,u,i,l=37*os+26,o=As[l];return o?(os=o.nextPos,o.result):(e=os,40===t.charCodeAt(os)?(r=Ie,os++):(r=Y,0===vs&&a(Ue)),r!==Y?(n=V(),n!==Y?(s=x(),s!==Y?(u=V(),u!==Y?(41===t.charCodeAt(os)?(i=Ze,os++):(i=Y,0===vs&&a(Me)),i!==Y?(cs=e,r=tr(s),e=r):(os=e,e=K)):(os=e,e=K)):(os=e,e=K)):(os=e,e=K)):(os=e,e=K),As[l]={nextPos:os,result:e},e)}function j(){var e,r,n,s,u,i,l,o=37*os+27,c=As[o];if(c)return os=c.nextPos,c.result;if(vs++,e=os,r=os,n=os,s=os,vs++,u=M(),vs--,u===Y?s=rr:(os=s,s=K),s!==Y)if(nr.test(t.charAt(os))?(u=t.charAt(os),os++):(u=Y,0===vs&&a(sr)),u!==Y){for(i=[],ur.test(t.charAt(os))?(l=t.charAt(os),os++):(l=Y,0===vs&&a(ir));l!==Y;)i.push(l),ur.test(t.charAt(os))?(l=t.charAt(os),os++):(l=Y,0===vs&&a(ir));i!==Y?(s=[s,u,i],n=s):(os=n,n=K)}else os=n,n=K;else os=n,n=K;return n!==Y&&(n=t.substring(r,os)),r=n,r!==Y&&(cs=e,r=ar(r)),e=r,vs--,e===Y&&(r=Y,0===vs&&a(er)),As[o]={nextPos:os,result:e},e}function z(){var e,r,n,s,u,i=37*os+28,l=As[i];if(l)return os=l.nextPos,l.result;if(vs++,e=os,34===t.charCodeAt(os)?(r=or,os++):(r=Y,0===vs&&a(cr)),r!==Y){for(n=[],s=I(),s===Y&&(pr.test(t.charAt(os))?(s=t.charAt(os),os++):(s=Y,0===vs&&a(fr)));s!==Y;)n.push(s),s=I(),s===Y&&(pr.test(t.charAt(os))?(s=t.charAt(os),os++):(s=Y,0===vs&&a(fr)));n!==Y?(34===t.charCodeAt(os)?(s=or,os++):(s=Y,0===vs&&a(cr)),s!==Y?(cs=e,r=dr(n),e=r):(os=e,e=K)):(os=e,e=K)}else os=e,e=K;if(e===Y)if(e=os,39===t.charCodeAt(os)?(r=hr,os++):(r=Y,0===vs&&a(vr)),r!==Y){for(n=os,s=[],t.substr(os,2)===Ar?(u=Ar,os+=2):(u=Y,0===vs&&a(yr)),u===Y&&(xr.test(t.charAt(os))?(u=t.charAt(os),os++):(u=Y,0===vs&&a(br)));u!==Y;)s.push(u),t.substr(os,2)===Ar?(u=Ar,os+=2):(u=Y,0===vs&&a(yr)),u===Y&&(xr.test(t.charAt(os))?(u=t.charAt(os),os++):(u=Y,0===vs&&a(br)));s!==Y&&(s=t.substring(n,os)),n=s,n!==Y?(39===t.charCodeAt(os)?(s=hr,os++):(s=Y,0===vs&&a(vr)),s!==Y?(cs=e,r=Pr(n),e=r):(os=e,e=K)):(os=e,e=K)}else os=e,e=K;return vs--,e===Y&&(r=Y,0===vs&&a(lr)),As[i]={nextPos:os,result:e},e}function I(){var e,r,n,s,u,i,l,o,c=37*os+29,p=As[c];return p?(os=p.nextPos,p.result):(vs++,e=os,t.substr(os,2)===Cr?(r=Cr,os+=2):(r=Y,0===vs&&a(mr)),r!==Y&&(cs=e,r=Er()),e=r,e===Y&&(e=os,t.substr(os,2)===Sr?(r=Sr,os+=2):(r=Y,0===vs&&a(Qr)),r!==Y&&(cs=e,r=_r()),e=r,e===Y&&(e=os,39===t.charCodeAt(os)?(r=hr,os++):(r=Y,0===vs&&a(vr)),r!==Y&&(cs=e,r=Rr()),e=r,e===Y&&(e=os,t.substr(os,2)===wr?(r=wr,os+=2):(r=Y,0===vs&&a(Fr)),r!==Y&&(cs=e,r=qr()),e=r,e===Y&&(e=os,t.substr(os,2)===Tr?(r=Tr,os+=2):(r=Y,0===vs&&a(Lr)),r!==Y&&(cs=e,r=Nr()),e=r,e===Y&&(e=os,t.substr(os,2)===kr?(r=kr,os+=2):(r=Y,0===vs&&a(jr)),r!==Y&&(cs=e,r=zr()),e=r,e===Y&&(e=os,t.substr(os,2)===Ir?(r=Ir,os+=2):(r=Y,0===vs&&a(Ur)),r!==Y&&(cs=e,r=Zr()),e=r,e===Y&&(e=os,t.substr(os,2)===Mr?(r=Mr,os+=2):(r=Y,0===vs&&a(Vr)),r!==Y&&(cs=e,r=Jr()),e=r,e===Y&&(e=os,t.substr(os,2)===Br?(r=Br,os+=2):(r=Y,0===vs&&a(Gr)),r!==Y&&(cs=e,r=Or()),e=r,e===Y&&(e=os,t.substr(os,2)===Dr?(r=Dr,os+=2):(r=Y,0===vs&&a(Yr)),r!==Y&&(cs=e,r=$r()),e=r,e===Y&&(e=os,t.substr(os,2)===Hr?(r=Hr,os+=2):(r=Y,0===vs&&a(Kr)),r!==Y?(n=os,s=os,Wr.test(t.charAt(os))?(u=t.charAt(os),os++):(u=Y,0===vs&&a(Xr)),u!==Y?(Wr.test(t.charAt(os))?(i=t.charAt(os),os++):(i=Y,0===vs&&a(Xr)),i!==Y?(u=[u,i],s=u):(os=s,s=K)):(os=s,s=K),s!==Y&&(s=t.substring(n,os)),n=s,n!==Y?(cs=e,r=tn(n),e=r):(os=e,e=K)):(os=e,e=K),e===Y&&(e=os,t.substr(os,2)===en?(r=en,os+=2):(r=Y,0===vs&&a(rn)),r!==Y?(n=os,s=os,Wr.test(t.charAt(os))?(u=t.charAt(os),os++):(u=Y,0===vs&&a(Xr)),u!==Y?(Wr.test(t.charAt(os))?(i=t.charAt(os),os++):(i=Y,0===vs&&a(Xr)),i!==Y?(Wr.test(t.charAt(os))?(l=t.charAt(os),os++):(l=Y,0===vs&&a(Xr)),l!==Y?(Wr.test(t.charAt(os))?(o=t.charAt(os),os++):(o=Y,0===vs&&a(Xr)),o!==Y?(u=[u,i,l,o],s=u):(os=s,s=K)):(os=s,s=K)):(os=s,s=K)):(os=s,s=K),s!==Y&&(s=t.substring(n,os)),n=s,n!==Y?(cs=e,r=tn(n),e=r):(os=e,e=K)):(os=e,e=K)))))))))))),vs--,e===Y&&(r=Y,0===vs&&a(gr)),As[c]={nextPos:os,result:e},e)}function U(){var e,r,n,s,u,i=37*os+30,l=As[i];if(l)return os=l.nextPos,l.result;if(vs++,e=os,96===t.charCodeAt(os)?(r=sn,os++):(r=Y,0===vs&&a(un)),r!==Y){for(n=os,s=[],t.substr(os,2)===an?(u=an,os+=2):(u=Y,0===vs&&a(ln)),u===Y&&(on.test(t.charAt(os))?(u=t.charAt(os),os++):(u=Y,0===vs&&a(cn)));u!==Y;)s.push(u),t.substr(os,2)===an?(u=an,os+=2):(u=Y,0===vs&&a(ln)),u===Y&&(on.test(t.charAt(os))?(u=t.charAt(os),os++):(u=Y,0===vs&&a(cn)));s!==Y&&(s=t.substring(n,os)),n=s,n!==Y?(96===t.charCodeAt(os)?(s=sn,os++):(s=Y,0===vs&&a(un)),s!==Y?(cs=e,r=pn(n),e=r):(os=e,e=K)):(os=e,e=K)}else os=e,e=K;return vs--,e===Y&&(r=Y,0===vs&&a(nn)),As[i]={nextPos:os,result:e},e}function Z(){var e,r,n,s,u,i,l,o,c,p,f,d,h=37*os+31,v=As[h];if(v)return os=v.nextPos,v.result;if(vs++,e=os,r=os,dn.test(t.charAt(os))?(n=t.charAt(os),os++):(n=Y,0===vs&&a(hn)),n===Y&&(n=nt),n!==Y&&(n=t.substring(r,os)),r=n,r!==Y)if(t.substr(os,2)===vn?(n=vn,os+=2):(n=Y,0===vs&&a(An)),n!==Y){if(s=os,u=[],yn.test(t.charAt(os))?(i=t.charAt(os),os++):(i=Y,0===vs&&a(xn)),i!==Y)for(;i!==Y;)u.push(i),yn.test(t.charAt(os))?(i=t.charAt(os),os++):(i=Y,0===vs&&a(xn));else u=K;u!==Y&&(u=t.substring(s,os)),s=u,s!==Y?(cs=e,r=bn(r,s),e=r):(os=e,e=K)}else os=e,e=K;else os=e,e=K;if(e===Y){if(e=os,r=os,dn.test(t.charAt(os))?(n=t.charAt(os),os++):(n=Y,0===vs&&a(hn)),n===Y&&(n=nt),n!==Y&&(n=t.substring(r,os)),r=n,r!==Y)if(t.substr(os,2)===Pn?(n=Pn,os+=2):(n=Y,0===vs&&a(gn)),n!==Y){if(s=os,u=[],Cn.test(t.charAt(os))?(i=t.charAt(os),os++):(i=Y,0===vs&&a(mn)),i!==Y)for(;i!==Y;)u.push(i),Cn.test(t.charAt(os))?(i=t.charAt(os),os++):(i=Y,0===vs&&a(mn));else u=K;u!==Y&&(u=t.substring(s,os)),s=u,s!==Y?(cs=e,r=En(r,s),e=r):(os=e,e=K)}else os=e,e=K;else os=e,e=K;if(e===Y){if(e=os,r=os,dn.test(t.charAt(os))?(n=t.charAt(os),os++):(n=Y,0===vs&&a(hn)),n===Y&&(n=nt),n!==Y&&(n=t.substring(r,os)),r=n,r!==Y)if(t.substr(os,2)===Sn?(n=Sn,os+=2):(n=Y,0===vs&&a(Qn)),n!==Y){if(s=os,u=[],Wr.test(t.charAt(os))?(i=t.charAt(os),os++):(i=Y,0===vs&&a(Xr)),i!==Y)for(;i!==Y;)u.push(i),Wr.test(t.charAt(os))?(i=t.charAt(os),os++):(i=Y,0===vs&&a(Xr));else u=K;u!==Y&&(u=t.substring(s,os)),s=u,s!==Y?(cs=e,r=_n(r,s),e=r):(os=e,e=K)}else os=e,e=K;else os=e,e=K;if(e===Y){if(e=os,r=os,n=os,dn.test(t.charAt(os))?(s=t.charAt(os),os++):(s=Y,0===vs&&a(hn)),s===Y&&(s=nt),s!==Y){for(u=[],Rn.test(t.charAt(os))?(i=t.charAt(os),os++):(i=Y,0===vs&&a(wn));i!==Y;)u.push(i),Rn.test(t.charAt(os))?(i=t.charAt(os),os++):(i=Y,0===vs&&a(wn));if(u!==Y)if(46===t.charCodeAt(os)?(i=Fn,os++):(i=Y,0===vs&&a(qn)),i!==Y){if(l=[],Rn.test(t.charAt(os))?(o=t.charAt(os),os++):(o=Y,0===vs&&a(wn)),o!==Y)for(;o!==Y;)l.push(o),Rn.test(t.charAt(os))?(o=t.charAt(os),os++):(o=Y,0===vs&&a(wn));else l=K;if(l!==Y){if(o=os,Tn.test(t.charAt(os))?(c=t.charAt(os),os++):(c=Y,0===vs&&a(Ln)),c!==Y)if(dn.test(t.charAt(os))?(p=t.charAt(os),os++):(p=Y,0===vs&&a(hn)),p===Y&&(p=nt),p!==Y){if(f=[],Rn.test(t.charAt(os))?(d=t.charAt(os),os++):(d=Y,0===vs&&a(wn)),d!==Y)for(;d!==Y;)f.push(d),Rn.test(t.charAt(os))?(d=t.charAt(os),os++):(d=Y,0===vs&&a(wn));else f=K;f!==Y?(c=[c,p,f],o=c):(os=o,o=K)}else os=o,o=K;else os=o,o=K;o===Y&&(o=nt),o!==Y?(s=[s,u,i,l,o],n=s):(os=n,n=K)}else os=n,n=K}else os=n,n=K;else os=n,n=K}else os=n,n=K;if(n!==Y&&(n=t.substring(r,os)),r=n,r!==Y&&(cs=e,r=Nn(r)),e=r,e===Y){if(e=os,r=os,n=os,dn.test(t.charAt(os))?(s=t.charAt(os),os++):(s=Y,0===vs&&a(hn)),s===Y&&(s=nt),s!==Y){if(u=[],Rn.test(t.charAt(os))?(i=t.charAt(os),os++):(i=Y,0===vs&&a(wn)),i!==Y)for(;i!==Y;)u.push(i),Rn.test(t.charAt(os))?(i=t.charAt(os),os++):(i=Y,0===vs&&a(wn));else u=K;u!==Y?(s=[s,u],n=s):(os=n,n=K)}else os=n,n=K;n!==Y&&(n=t.substring(r,os)),r=n,r!==Y&&(cs=e,r=kn(r)),e=r}}}}return vs--,e===Y&&(r=Y,0===vs&&a(fn)),As[h]={nextPos:os,result:e},e}function M(){var e,r,n=37*os+32,s=As[n];return s?(os=s.nextPos,s.result):(vs++,e=os,t.substr(os,4)===zn?(r=zn,os+=4):(r=Y,0===vs&&a(In)),r!==Y&&(cs=e,r=Un()),e=r,e===Y&&(e=os,t.substr(os,5)===Zn?(r=Zn,os+=5):(r=Y,0===vs&&a(Mn)),r!==Y&&(cs=e,r=Vn()),e=r,e===Y&&(e=os,t.substr(os,4)===Jn?(r=Jn,os+=4):(r=Y,0===vs&&a(Bn)),r!==Y&&(cs=e,r=Gn()),e=r,e===Y&&(e=os,t.substr(os,3)===On?(r=On,os+=3):(r=Y,0===vs&&a(Dn)),r!==Y&&(cs=e,r=Yn()),e=r,e===Y&&(e=os,t.substr(os,9)===$n?(r=$n,os+=9):(r=Y,0===vs&&a(Hn)),r!==Y&&(cs=e,r=Kn()),e=r)))),vs--,e===Y&&(r=Y,0===vs&&a(jn)),As[n]={nextPos:os,result:e},e)}function V(){var t,e,r=37*os+33,n=As[r];if(n)return os=n.nextPos,n.result;for(vs++,t=[],e=J(),e===Y&&(e=B());e!==Y;)t.push(e),e=J(),e===Y&&(e=B());return vs--,t===Y&&(e=Y,0===vs&&a(Wn)),As[r]={nextPos:os,result:t},t}function J(){var e,r,n,s,u,i,l=37*os+34,o=As[l];if(o)return os=o.nextPos,o.result;if(vs++,e=os,t.substr(os,2)===ts?(r=ts,os+=2):(r=Y,0===vs&&a(es)),r!==Y){for(n=[],s=os,u=os,vs++,t.substr(os,2)===rs?(i=rs,os+=2):(i=Y,0===vs&&a(ns)),vs--,i===Y?u=rr:(os=u,u=K),u!==Y?(t.length>os?(i=t.charAt(os),os++):(i=Y,0===vs&&a(ss)),i!==Y?(u=[u,i],s=u):(os=s,s=K)):(os=s,s=K);s!==Y;)n.push(s),s=os,u=os,vs++,t.substr(os,2)===rs?(i=rs,os+=2):(i=Y,0===vs&&a(ns)),vs--,i===Y?u=rr:(os=u,u=K),u!==Y?(t.length>os?(i=t.charAt(os),os++):(i=Y,0===vs&&a(ss)),i!==Y?(u=[u,i],s=u):(os=s,s=K)):(os=s,s=K);n!==Y?(t.substr(os,2)===rs?(s=rs,os+=2):(s=Y,0===vs&&a(ns)),s!==Y?(r=[r,n,s],e=r):(os=e,e=K)):(os=e,e=K)}else os=e,e=K;return vs--,e===Y&&(r=Y,0===vs&&a(Xn)),As[l]={nextPos:os,result:e},e}function B(){var e,r,n=37*os+35,s=As[n];if(s)return os=s.nextPos,s.result;if(vs++,e=[],is.test(t.charAt(os))?(r=t.charAt(os),os++):(r=Y,0===vs&&a(as)),r!==Y)for(;r!==Y;)e.push(r),is.test(t.charAt(os))?(r=t.charAt(os),os++):(r=Y,0===vs&&a(as));else e=K;return vs--,e===Y&&(r=Y,0===vs&&a(us)),As[n]={nextPos:os,result:e},e}function G(){var e,r,n=37*os+36,s=As[n];return s?(os=s.nextPos,s.result):(vs++,e=os,vs++,t.length>os?(r=t.charAt(os),os++):(r=Y,0===vs&&a(ss)),vs--,r===Y?e=rr:(os=e,e=K),vs--,e===Y&&(r=Y,0===vs&&a(ls)),As[n]={nextPos:os,result:e},e)}var O,D=arguments.length>1?arguments[1]:{},Y={},$={query:o},H=o,K=Y,W=function(t){return t},X=",",tt={type:"literal",value:",",description:'","'},et=function(t,e){return xs("Query").add(ys(t,e,3))},rt=function(t,e){return xs("Path").add(ys(t,e,1))},nt=null,st=function(t,e,r){return xs("Step").add(t,e,r)},ut={type:"other",description:"axis"},it="//",at={type:"literal",value:"//",description:'"//"'},lt="/",ot={type:"literal",value:"/",description:'"/"'},ct="-//",pt={type:"literal",value:"-//",description:'"-//"'},ft="-/",dt={type:"literal",value:"-/",description:'"-/"'},ht="+//",vt={type:"literal",value:"+//",description:'"+//"'},At="+/",yt={type:"literal",value:"+/",description:'"+/"'},xt="..//",bt={type:"literal",value:"..//",description:'"..//"'},Pt="../",gt={type:"literal",value:"../",description:'"../"'},Ct="<//",mt={type:"literal",value:"<//",description:'"<//"'},Et=">//",St={type:"literal",value:">//",description:'">//"'},Qt=function(t,e){return xs("Axis").set({op:t,type:null!==e?e:"*"})},_t=":",Rt={type:"literal",value:":",description:'":"'},wt=function(t){return t},Ft=function(t){return xs("Match").merge(t)},qt="*",Tt={type:"literal",value:"*",description:'"*"'},Lt=function(){return xs("Match").set({id:"*"})},Nt="[",kt={type:"literal",value:"[",description:'"["'},jt="]",zt={type:"literal",value:"]",description:'"]"'},It=function(t){return xs("Filter").add(t)},Ut="?:",Zt={type:"literal",value:"?:",description:'"?:"'},Mt=function(t,e){return xs("ConditionalBinary").add(t,e)},Vt="?",Jt={type:"literal",value:"?",description:'"?"'},Bt=function(t,e,r){return xs("ConditionalTernary").add(t,e,r)},Gt="||",Ot={type:"literal",value:"||",description:'"||"'},Dt=function(t,e,r){return xs("Logical").set({op:e}).add(t,r)},Yt="&&",$t={type:"literal",value:"&&",description:'"&&"'},Ht="|",Kt={type:"literal",value:"|",description:'"|"'},Wt=function(t,e,r){return xs("Bitwise").set({op:e}).add(t,r)},Xt="^",te={type:"literal",value:"^",description:'"^"'},ee="&",re={type:"literal",value:"&",description:'"&"'},ne="==",se={type:"literal",value:"==",description:'"=="'},ue="!=",ie={type:"literal",value:"!=",description:'"!="'},ae="<=",le={type:"literal",value:"<=",description:'"<="'},oe=">=",ce={type:"literal",value:">=",description:'">="'},pe="<",fe={type:"literal",value:"<",description:'"<"'},de=">",he={type:"literal",value:">",description:'">"'},ve="=~",Ae={type:"literal",value:"=~",description:'"=~"'},ye="!~",xe={type:"literal",value:"!~",description:'"!~"'},be=function(t,e,r){return xs("Relational").set({op:e}).add(t,r)},Pe="<<",ge={type:"literal",value:"<<",description:'"<<"'},Ce=">>",me={type:"literal",value:">>",description:'">>"'},Ee="+",Se={type:"literal",value:"+",description:'"+"'},Qe="-",_e={type:"literal",value:"-",description:'"-"'},Re=function(t,e,r){return xs("Arithmetical").set({op:e}).add(t,r)},we="**",Fe={type:"literal",value:"**",description:'"**"'},qe="%",Te={type:"literal",value:"%",description:'"%"'},Le="!",Ne={type:"literal",value:"!",description:'"!"'},ke="~",je={type:"literal",value:"~",description:'"~"'},ze=function(t,e){return xs("Unary").set({op:t}).add(e)},Ie="(",Ue={type:"literal",value:"(",description:'"("'},Ze=")",Me={type:"literal",value:")",description:'")"'},Ve=function(t,e){return xs("FuncCall").merge(t).add(e)},Je=function(t,e){return ys(t,e,3)},Be={type:"other",description:"node attribute"},Ge="@",Oe={type:"literal",value:"@",description:'"@"'},De=function(t){return xs("Attribute").merge(t)},Ye={type:"other",description:"query parameter reference"},$e="{",He={type:"literal",value:"{",description:'"{"'},Ke="}",We={type:"literal",value:"}",description:'"}"'},Xe=function(t){return xs("Param").merge(t)},tr=function(t){return t},er={type:"other",description:"identifier"},rr=void 0,nr=/^[a-zA-Z_]/,sr={type:"class",value:"[a-zA-Z_]",description:"[a-zA-Z_]"},ur=/^[a-zA-Z0-9_\-]/,ir={type:"class",value:"[a-zA-Z0-9_\\-]",description:"[a-zA-Z0-9_\\-]"},ar=function(t){return xs("Identifier").set({id:t})},lr={type:"other",description:"quoted string literal"},or='"',cr={type:"literal",value:'"',description:'"\\""'},pr=/^[^"]/,fr={type:"class",value:'[^"]',description:'[^"]'},dr=function(t){return xs("LiteralString").set({value:t.join("")})},hr="'",vr={type:"literal",value:"'",description:'"\'"'},Ar="\\'",yr={type:"literal",value:"\\'",description:'"\\\\\'"'},xr=/^[^']/,br={type:"class",value:"[^']",description:"[^']"},Pr=function(t){return xs("LiteralString").set({value:t.replace(/\\'/g,"'")})},gr={type:"other",description:"escaped string character"},Cr="\\\\",mr={type:"literal",value:"\\\\",description:'"\\\\\\\\"'},Er=function(){return"\\"},Sr='\\"',Qr={type:"literal",value:'\\"',description:'"\\\\\\""'},_r=function(){return'"'},Rr=function(){return"'"},wr="\\b",Fr={type:"literal",value:"\\b",description:'"\\\\b"'},qr=function(){return"\b"},Tr="\\v",Lr={type:"literal",value:"\\v",description:'"\\\\v"'},Nr=function(){return""},kr="\\f",jr={type:"literal",value:"\\f",description:'"\\\\f"'},zr=function(){return"\f"},Ir="\\t",Ur={type:"literal",value:"\\t",description:'"\\\\t"'},Zr=function(){return"	"},Mr="\\r",Vr={type:"literal",value:"\\r",description:'"\\\\r"'},Jr=function(){return"\r"},Br="\\n",Gr={type:"literal",value:"\\n",description:'"\\\\n"'},Or=function(){return"\n"},Dr="\\e",Yr={type:"literal",value:"\\e",description:'"\\\\e"'},$r=function(){return""},Hr="\\x",Kr={type:"literal",value:"\\x",description:'"\\\\x"'},Wr=/^[0-9a-fA-F]/,Xr={type:"class",value:"[0-9a-fA-F]",description:"[0-9a-fA-F]"},tn=function(t){return String.fromCharCode(parseInt(t,16))},en="\\u",rn={type:"literal",value:"\\u",description:'"\\\\u"'},nn={type:"other",description:"regular expression literal"},sn="`",un={type:"literal",value:"`",description:'"`"'},an="\\`",ln={type:"literal",value:"\\`",description:'"\\\\`"'},on=/^[^`]/,cn={type:"class",value:"[^`]",description:"[^`]"},pn=function(t){var e;try{e=new RegExp(t.replace(/\\`/g,"`"))}catch(r){u(r.message)}return xs("LiteralRegExp").set({value:e})},fn={type:"other",description:"numeric literal"},dn=/^[+\-]/,hn={type:"class",value:"[+\\-]",description:"[+\\-]"},vn="0b",An={type:"literal",value:"0b",description:'"0b"'},yn=/^[01]/,xn={type:"class",value:"[01]",description:"[01]"},bn=function(t,e){return xs("LiteralNumber").set({value:parseInt(t+e,2)})},Pn="0o",gn={type:"literal",value:"0o",description:'"0o"'},Cn=/^[0-7]/,mn={type:"class",value:"[0-7]",description:"[0-7]"},En=function(t,e){return xs("LiteralNumber").set({value:parseInt(t+e,8)})},Sn="0x",Qn={type:"literal",value:"0x",description:'"0x"'},_n=function(t,e){return xs("LiteralNumber").set({value:parseInt(t+e,16)})},Rn=/^[0-9]/,wn={type:"class",value:"[0-9]",description:"[0-9]"},Fn=".",qn={type:"literal",value:".",description:'"."'},Tn=/^[eE]/,Ln={type:"class",value:"[eE]",description:"[eE]"},Nn=function(t){return xs("LiteralNumber").set({value:parseFloat(t)})},kn=function(t){return xs("LiteralNumber").set({value:parseInt(t,10)})},jn={type:"other",description:"global value"},zn="true",In={type:"literal",value:"true",description:'"true"'},Un=function(){return xs("LiteralValue").set({value:!0})},Zn="false",Mn={type:"literal",value:"false",description:'"false"'},Vn=function(){return xs("LiteralValue").set({value:!1})},Jn="null",Bn={type:"literal",value:"null",description:'"null"'},Gn=function(){return xs("LiteralValue").set({value:null})},On="NaN",Dn={type:"literal",value:"NaN",description:'"NaN"'},Yn=function(){return xs("LiteralValue").set({value:NaN})},$n="undefined",Hn={type:"literal",value:"undefined",description:'"undefined"'},Kn=function(){return xs("LiteralValue").set({value:void 0})},Wn={type:"other",description:"optional blank"},Xn={type:"other",description:"multi-line comment"},ts="/*",es={type:"literal",value:"/*",description:'"/*"'},rs="*/",ns={type:"literal",value:"*/",description:'"*/"'},ss={type:"any",description:"any character"},us={type:"other",description:"any whitespaces"},is=/^[ \t\r\n]/,as={type:"class",value:"[ \\t\\r\\n]",description:"[ \\t\\r\\n]"},ls={type:"other",description:"end of file"},os=0,cs=0,ps=0,fs={line:1,column:1,seenCR:!1},ds=0,hs=[],vs=0,As={};if("startRule"in D){if(!(D.startRule in $))throw new Error("Can't start parsing from rule \""+D.startRule+'".');H=$[D.startRule]}var ys=D.util.makeUnroll(n,s,r,e),xs=D.util.makeAST(n,s,r,D);if(O=H(),O!==Y&&os===t.length)return O;throw O!==Y&&os<t.length&&a({type:"end",description:"end of input"}),l(null,hs,ds)}return t(e,Error),{SyntaxError:e,parse:r}}(),ASTQQuery=function(){function t(e){_classCallCheck(this,t),this.asty=new ASTY,this.ast=null,e&&this.compile(e)}return _createClass(t,[{key:"compile",value:function(t,e){var r=this;e&&console.log("ASTQ: compile: +-------------------------------------------------------------------------------------------------------\nASTQ: compile: | "+t);var n=PEGUtil.parse(ASTQQueryParse,t,{startRule:"query",makeAST:function(t,e,n,s){return r.asty.create.apply(r.asty,s).pos(t,e,n)}});if(null!==n.error)throw new Error("ASTQ: compile: query parsing failed:\n"+PEGUtil.errorMessage(n.error,!0).replace(/^/gm,"ERROR: "));return this.ast=n.ast,e&&console.log("ASTQ: compile: +-------------------------------------------------------------------------------------------------------\n"+this.dump().replace(/\n$/,"").replace(/^/gm,"ASTQ: compile: | ")),this}},{key:"dump",value:function(){
return this.ast.dump()}},{key:"execute",value:function(t,e,r,n,s){s&&console.log("ASTQ: execute: +--------------------------------------------------------------+----------------------------------------");var u=new _astqQueryExecJs2["default"](e,r,n,s);return u.execQuery(this.ast,t)}}]),t}();exports["default"]=ASTQQuery,module.exports=exports["default"];
},{"./astq-query-exec.js":10,"asty":1,"pegjs-util":3}],13:[function(_dereq_,module,exports){
"use strict";function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}Object.defineProperty(exports,"__esModule",{value:!0});var _createClass=function(){function e(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}return function(t,r,n){return r&&e(t.prototype,r),n&&e(t,n),t}}(),ASTQUtil=function(){function e(){_classCallCheck(this,e)}return _createClass(e,null,[{key:"pad",value:function t(e,r){var n=0>r?-r:r;if(e.length>n)e=e.substr(0,n);else{var t=Array(n+1-e.length).join(" ");e=0>r?e+t:t+e}return e}},{key:"truthy",value:function(e){var t=void 0;switch(typeof e){case"boolean":t=e;break;case"number":t=0!==e&&!isNaN(e);break;case"string":t=""!==e;break;case"object":t=!1,null!==e&&(t=!0,e instanceof Array&&(t=e.length>0));break;default:t=!1}return t}},{key:"coerce",value:function(e,t){if(typeof e!==t)try{switch(t){case"boolean":"boolean"!=typeof e&&(e=Boolean(e));break;case"number":"number"!=typeof e&&(e=Number(e));break;case"string":"string"!=typeof e&&(e=String(e));break;case"regexp":"object"==typeof e&&e instanceof RegExp||(e=new RegExp(e))}}catch(r){throw new Error("cannot coerce value into type "+t)}return e}}]),e}();exports["default"]=ASTQUtil,module.exports=exports["default"];
},{}],14:[function(_dereq_,module,exports){
"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var version={major:1,minor:5,micro:2,date:20150819};exports["default"]=version,module.exports=exports["default"];
},{}],15:[function(_dereq_,module,exports){
"use strict";function _interopRequireDefault(e){return e&&e.__esModule?e:{"default":e}}function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}Object.defineProperty(exports,"__esModule",{value:!0});var _createClass=function(){function e(e,t){for(var r=0;r<t.length;r++){var s=t[r];s.enumerable=s.enumerable||!1,s.configurable=!0,"value"in s&&(s.writable=!0),Object.defineProperty(e,s.key,s)}}return function(t,r,s){return r&&e(t.prototype,r),s&&e(t,s),t}}(),_astqAdapterJs=_dereq_("./astq-adapter.js"),_astqAdapterJs2=_interopRequireDefault(_astqAdapterJs),_astqAdapterAstyJs=_dereq_("./astq-adapter-asty.js"),_astqAdapterAstyJs2=_interopRequireDefault(_astqAdapterAstyJs),_astqAdapterMozastJs=_dereq_("./astq-adapter-mozast.js"),_astqAdapterMozastJs2=_interopRequireDefault(_astqAdapterMozastJs),_astqAdapterXmldomJs=_dereq_("./astq-adapter-xmldom.js"),_astqAdapterXmldomJs2=_interopRequireDefault(_astqAdapterXmldomJs),_astqFuncsJs=_dereq_("./astq-funcs.js"),_astqFuncsJs2=_interopRequireDefault(_astqFuncsJs),_astqFuncsStdJs=_dereq_("./astq-funcs-std.js"),_astqFuncsStdJs2=_interopRequireDefault(_astqFuncsStdJs),_astqQueryJs=_dereq_("./astq-query.js"),_astqQueryJs2=_interopRequireDefault(_astqQueryJs),_astqVersionJs=_dereq_("./astq-version.js"),_astqVersionJs2=_interopRequireDefault(_astqVersionJs),CacheLRU=_dereq_("cache-lru"),ASTQ=function(){function e(){_classCallCheck(this,e),this._adapter=new _astqAdapterJs2["default"],this._adapter.register(_astqAdapterMozastJs2["default"]),this._adapter.register(_astqAdapterXmldomJs2["default"]),this._adapter.register(_astqAdapterAstyJs2["default"]),this._funcs=new _astqFuncsJs2["default"];for(var t in _astqFuncsStdJs2["default"])this.func(t,_astqFuncsStdJs2["default"][t]);this._cache=new CacheLRU}return _createClass(e,[{key:"version",value:function(){return _astqVersionJs2["default"]}},{key:"adapter",value:function(e){if(1!==arguments.length)throw new Error("ASTQ#adapter: invalid number of arguments");return this._adapter.unregister(),this._adapter.register(e),this}},{key:"func",value:function(e,t){if(2!==arguments.length)throw new Error("ASTQ#func: invalid number of arguments");return this._funcs.register(e,t),this}},{key:"cache",value:function(e){if(1!==arguments.length)throw new Error("ASTQ#cache: invalid number of arguments");return this._cache.limit(e),this}},{key:"compile",value:function(e,t){if(arguments.length<1)throw new Error("ASTQ#compile: too less arguments");if(arguments.length>2)throw new Error("ASTQ#compile: too many arguments");void 0===t&&(t=!1);var r=this._cache.get(e);return void 0===r&&(r=new _astqQueryJs2["default"],r.compile(e,t),this._cache.set(e,r)),r}},{key:"execute",value:function(e,t,r,s){if(arguments.length<2)throw new Error("ASTQ#execute: too less arguments");if(arguments.length>4)throw new Error("ASTQ#execute: too many arguments");void 0===r&&(r={}),void 0===s&&(s=!1);var a=this._adapter.select(e);if(void 0===a)throw new Error("ASTQ#execute: no suitable adapter found for node");return t.execute(e,a,r,this._funcs,s)}},{key:"query",value:function(e,t,r,s){if(arguments.length<2)throw new Error("ASTQ#query: too less arguments");if(arguments.length>4)throw new Error("ASTQ#query: too many arguments");return void 0===r&&(r={}),void 0===s&&(s=!1),this.execute(e,this.compile(t,s),r,s)}}]),e}();exports["default"]=ASTQ,module.exports=exports["default"];
},{"./astq-adapter-asty.js":4,"./astq-adapter-mozast.js":5,"./astq-adapter-xmldom.js":6,"./astq-adapter.js":7,"./astq-funcs-std.js":8,"./astq-funcs.js":9,"./astq-query.js":12,"./astq-version.js":14,"cache-lru":2}]},{},[4,5,6,7,8,9,10,11,12,13,14,15])(15)
});


//# sourceMappingURL=astq.browser.map